"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AsyncLazy = void 0;
class AsyncLazy {
    constructor(executor) {
        this.executor = executor;
        this.#promise = null;
    }
    #promise;
    invoke() {
        return (this.#promise =
            this.#promise ||
                new Promise((resolve, reject) => this.executor().then(resolve, reject)));
    }
    then(onFulfilled, onRejected) {
        return this.invoke().then(onFulfilled, onRejected);
    }
}
exports.AsyncLazy = AsyncLazy;
